#! /bin/bash

# Create repository, at $repopath aka $repourl.
# This bug is only reproducable using HTTP, so you will need Apache set up.
#
# The "rm -rf" line is commented out for safety; feel free to uncomment it
# if you want to run this script repeatedly
repopath=/srv/svn/foobar
repourl=http://localhost/svn/foobar
#rm -rf $repopath
svnadmin create $repopath
chmod -R a+rwx $repopath

# Write a pre-revprop-change hook that always succeeds
echo '#! /bin/bash' >$repopath/hooks/pre-revprop-change
chmod a+rx $repopath/hooks/pre-revprop-change

svn propset TESTPROP --revprop -r0 OLDVAL $repourl

# Write a pre-revprop-change hook that fails for the new value but not the old.
echo '#! /bin/bash' >$repopath/hooks/pre-revprop-change
echo 'grep FORBIDDEN || exit 0' >>$repopath/hooks/pre-revprop-change
echo 'echo Hook script is blocking commit 1>&2' >>$repopath/hooks/pre-revprop-change
echo 'exit 1' >>$repopath/hooks/pre-revprop-change
chmod a+rx $repopath/hooks/pre-revprop-change

echo '================='
svn propset TESTPROP --revprop -r0 FORBIDDEN $repourl

# Expected output:
#   [...]
#   =================
#   [... other error messages snipped ...]
#   Hook script is blocking commit
#
# Actual output:
#   [...]
#   =================
#   [... other error messages snipped ...]
#   Could not execute PROPPATCH.


